--  C:\DOCUMENTS AND SETTINGS\MATAR\DESKTOP\BEER_MODEL\BEER_PROJECT.vhd
--  VHDL code created by Xilinx's StateCAD 9.2i
--  Mon March 02 16:36:54 2008

--  This VHDL code (for use with IEEE compliant tools) was generated using: 
--  one-hot state assignment with boolean code format.
--  Minimization is enabled,  implied else is enabled, 
--  and outputs are manually optimized.

LIBRARY ieee;
USE ieee.std_logic_1164.all;

use IEEE.STD_LOGIC_UNSIGNED.ALL; -- new line added to do std_logic_vector addition using "+"

ENTITY BEER_PROJECT IS
	PORT (CLK,L,RESET,T: IN std_logic;
		CHILLER,HEATER,PUMP,VALVE : OUT std_logic);
END;

ARCHITECTURE BEHAVIOR OF BEER_PROJECT IS
--	State variables for machine sreg
	SIGNAL STATE0, next_STATE0, STATE1, next_STATE1, STATE2, next_STATE2, STATE3
		, next_STATE3 : std_logic;
		
signal slow_clk : std_logic;	-- new line added to accomodate slow_clk signal
signal clk_divider : std_logic_vector(24 downto 0) := (others => '0');	-- new line added to do clock division

BEGIN
		
	-- *** new process added to do clock division ***
	clk_division : process (clk, clk_divider) 
	begin
		if (clk = '1' and clk'Event) then
			clk_divider <= clk_divider + 1;
		end if;
		slow_clk <= clk_divider(24);
	end process;
	-- ***********************************************
--Explanation
		--frequency = (system clock frequency)/ 2^25
		--Here system clock runs at 50Mhz.
		--So the slow_clk runs at 1.49Hz (Since clk_divider(24) runs at 50Mhz/2^25).
	
	
	PROCESS (slow_clk, RESET, next_STATE0, next_STATE1, next_STATE2, next_STATE3)
	--PROCESS (CLK, RESET)
	BEGIN
		IF ( RESET='1' ) THEN
			STATE0 <= '1';
			STATE1 <= '0';
			STATE2 <= '0';
			STATE3 <= '0';
		ELSIF slow_clk='1' AND slow_clk'event THEN
			STATE0 <= next_STATE0;
			STATE1 <= next_STATE1;
			STATE2 <= next_STATE2;
			STATE3 <= next_STATE3;
		END IF;
	END PROCESS;

	PROCESS (L,STATE0,STATE1,STATE2,STATE3,T)
	BEGIN

		IF (( L='0' AND  (STATE0='1')) OR ( L='0' AND  (STATE3='1'))) THEN 
			next_STATE0<='1';
		ELSE next_STATE0<='0';
		END IF;

		IF (( L='1' AND  (STATE0='1')) OR ( T='0' AND  (STATE1='1'))) THEN 
			next_STATE1<='1';
		ELSE next_STATE1<='0';
		END IF;

		IF (( T='1' AND  (STATE1='1')) OR ( T='1' AND  (STATE2='1'))) THEN 
			next_STATE2<='1';
		ELSE next_STATE2<='0';
		END IF;

		IF (( T='0' AND  (STATE2='1')) OR ( L='1' AND  (STATE3='1'))) THEN 
			next_STATE3<='1';
		ELSE next_STATE3<='0';
		END IF;


		IF ((  (STATE2='1'))) THEN CHILLER<='1';
		ELSE CHILLER<='0';
		END IF;

		IF ((  (STATE1='1'))) THEN HEATER<='1';
		ELSE HEATER<='0';
		END IF;

		IF ((  (STATE3='1'))) THEN PUMP<='1';
		ELSE PUMP<='0';
		END IF;

		IF ((  (STATE0='1'))) THEN VALVE<='1';
		ELSE VALVE<='0';
		END IF;
	END PROCESS;
END BEHAVIOR;

